UNIT mTxmlAutomat; {mk 10.4.04 }

interface

//--------------------  ggf Uses-Liste anpassen !  --------------------
uses
  classes;

type
   TxmlAutomat = CLASS

     // weitere Attribute
     private
        fa : array of array of integer;
        fue : array of array of integer;
        Fanfangszustand : integer;
        Fausgabe : integer;
        Feingabe : integer;
        Fzustand : integer;
        Fname : string;
        ausgaben : TStringList;
        eingaben : TStringList;
        zustaende : TStringList;

     // weitere Methoden
     public
        constructor Create;
        procedure initialisiere(beschreibung:string);
        procedure setAusgabe(pAusgabe:integer);
        procedure setEingabe(pEingabe:integer);
        procedure SetZustand(pZustand:integer);
        procedure verarbeiteEingabe;
        function getAnfangszustand : integer;
        function getAusgabe : integer;
        function getAusgabename(nr:integer) : string;
        function getAusgabenN : integer;
        function getEingabe : integer;
        function getEingabename(nr:integer) : string;
        function getEingabenN : integer;
        function getName : string;
        function getZustaendeN : integer;
        function getZustand : integer;
        function getZustandsname(nr:integer) : string;
        destructor destroy; override;
   end;

implementation

//+---------------------------------------------------------------------
//|         TxmlAutomat: Methodendefinition 
//+---------------------------------------------------------------------

//-------- Create (public) ---------------------------------------------
constructor TxmlAutomat.Create;
begin
  inherited Create;
  zustaende := TStringList.Create;
  eingaben  := TStringlist.Create;
  ausgaben  := TStringList.Create;
end;

//-------- initialisiere (public) --------------------------------------
procedure TxmlAutomat.initialisiere(beschreibung:string);
var
  p1,p2,p       : integer;
  st,az,nz,e,a  : string;
begin
  // Automatenname
  p := pos('<automat',beschreibung);
  beschreibung := Copy(beschreibung,p+8,Length(beschreibung)-p);
  p := pos('"',beschreibung);
  beschreibung := Copy(beschreibung,p+1,Length(beschreibung)-p);
  p := pos('"',beschreibung);
  Fname := Copy(beschreibung,1,p-1);
  beschreibung := Copy(beschreibung,p+1,Length(beschreibung)-p);
  //Zustnde
  zustaende.Clear;
  p := pos('</zustandsmenge>',beschreibung);
  p1 := pos('<zustand>',beschreibung);
  while (p1 > 0) and (p1 < p) do
  begin
    p2 := pos('</zustand>',beschreibung);
    if p2 > 0 then
    begin
      st := Copy(beschreibung,p1+9,p2-p1-9); // Length('<zustand>') = 9
      zustaende.Add(st);
      beschreibung := Copy(beschreibung,p2+10,Length(beschreibung)-p2+1);
      p := pos('</zustandsmenge>',beschreibung);
      p1 := pos('<zustand>',beschreibung);
    end
    else
      p1 := 0;
  end;
  // Anfangszustand
  p1 := pos('<zustand>',beschreibung);
  p2 := pos('</zustand>',beschreibung);
  if (p1 > 0) and (p2 > 0) then
  begin
    st := Copy(beschreibung,p1+9,p2-p1-9); // Length('<zustand>') = 9
    FAnfangszustand := zustaende.indexOf(st);
    FZustand := FAnfangszustand;
    beschreibung := Copy(beschreibung,p2+10,Length(beschreibung)-p2+1);
  end;
  // Eingaben
  eingaben.Clear;
  p1 := pos('<eingabe>',beschreibung);
  while (p1 > 0) do
  begin
    p2 := pos('</eingabe>',beschreibung);
    if p2 > 0 then
    begin
      st := Copy(beschreibung,p1+9,p2-p1-9); // Length('<eingabe>') = 9
      eingaben.Add(st);
      beschreibung := Copy(beschreibung,p2+10,Length(beschreibung)-p2+1);
      p1 := pos('<eingabe>',beschreibung);
    end
    else
      p1 := 0;
  end;
  // Ausgaben
  ausgaben.Clear;
  p1 := pos('<ausgabe>',beschreibung);
  while (p1 > 0) do
  begin
    p2 := pos('</ausgabe>',beschreibung);
    if p2 > 0 then
    begin
      st := Copy(beschreibung,p1+9,p2-p1-9); // Length('<ausgabe>') = 9
      ausgaben.Add(st);
      beschreibung := Copy(beschreibung,p2+10,Length(beschreibung)-p2+1);
      p1 := pos('<ausgabe>',beschreibung);
    end
    else
      p1 := 0;
  end;
  // berfhrungsfunktion
  SetLength(fue,GetZustaendeN,GetEingabenN);
  p1 := pos('<delta>',beschreibung);
  while (p1 > 0) do
  begin
    p2 := pos('</delta>',beschreibung);
    if p2 > 0 then
    begin
      st := Copy(beschreibung,p1+7,p2-p1-7); // Length('<delta>') = 7
      p := pos(',',st);
      az := Copy(st,1,p-1);
      st := Copy(st,p+1,Length(st)-p);
      p := pos(',',st);
      e := Copy(st,1,p-1);
      nz := Copy(st,p+1,Length(st)-p);
      if (Zustaende.IndexOf(az) > -1) and
         (Eingaben.IndexOf(e) > -1)   and
         (Zustaende.IndexOf(nz) > -1)
      then
        fue[Zustaende.IndexOf(az),Eingaben.IndexOf(e)] := Zustaende.IndexOf(nz);
      beschreibung := Copy(beschreibung,p2+8,Length(beschreibung)-p2+1);
      p1 := pos('<delta>',beschreibung);
    end
    else
      p1 := 0;
  end;
  // Ausgabefunktion
  SetLength(fa,GetZustaendeN,GetEingabenN);
  p1 := pos('<lambda>',beschreibung);
  while (p1 > 0) do
  begin
    p2 := pos('</lambda>',beschreibung);
    if p2 > 0 then
    begin
      st := Copy(beschreibung,p1+8,p2-p1-8); // Length('<lambda>') = 8
      p := pos(',',st);
      az := Copy(st,1,p-1);
      st := Copy(st,p+1,Length(st)-p);
      p := pos(',',st);
      e := Copy(st,1,p-1);
      a := Copy(st,p+1,Length(st)-p);
      if (Zustaende.IndexOf(az) > -1) and
         (Eingaben.IndexOf(e) > -1)   and
         (Ausgaben.IndexOf(a) > -1)
      then
        fa[Zustaende.IndexOf(az),Eingaben.IndexOf(e)] := Ausgaben.IndexOf(a);
      beschreibung := Copy(beschreibung,p2+9,Length(beschreibung)-p2+1);
      p1 := pos('<lambda>',beschreibung);
    end
    else
      p1 := 0;
  end;
end;

//-------- setAusgabe (public) -----------------------------------------
procedure TxmlAutomat.setAusgabe(pAusgabe:integer);
begin
  FAusgabe := pAusgabe
end;

//-------- setEingabe (public) -----------------------------------------
procedure TxmlAutomat.setEingabe(pEingabe:integer);
begin
  FEingabe := pEingabe
end;

//-------- SetZustand (public) -----------------------------------------
procedure TxmlAutomat.SetZustand(pZustand:integer);
begin
  FZustand := pZustand
end;

//-------- verarbeiteEingabe (public) ----------------------------------
procedure TxmlAutomat.verarbeiteEingabe;
begin
  FAusgabe := fa[FZustand,FEingabe];
  FZustand := fue[FZustand,FEingabe];
end;

//-------- getAnfangszustand (public) ----------------------------------
function TxmlAutomat.getAnfangszustand : integer;
begin
  result  := FAnfangszustand;
end;

//-------- getAusgabe (public) -----------------------------------------
function TxmlAutomat.getAusgabe : integer;
begin
  result  := FAusgabe;
end;

//-------- getAusgabename (public) -------------------------------------
function TxmlAutomat.getAusgabename(nr:integer) : string;
begin
  result := ausgaben[nr];
end;

//-------- getAusgabenN (public) ---------------------------------------
function TxmlAutomat.getAusgabenN : integer;
begin
  result := ausgaben.Count;;
end;

//-------- getEingabe (public) -----------------------------------------
function TxmlAutomat.getEingabe : integer;
begin
  result  := Feingabe
end;

//-------- getEingabename (public) -------------------------------------
function TxmlAutomat.getEingabename(nr:integer) : string;
begin
  result := eingaben[nr];
end;

//-------- getEingabenN (public) ---------------------------------------
function TxmlAutomat.getEingabenN : integer;
begin
  result := eingaben.Count;
end;

//-------- getName (public) --------------------------------------------
function TxmlAutomat.getName : string;
begin
  result  := FName
end;

//-------- getZustaendeN (public) --------------------------------------
function TxmlAutomat.getZustaendeN : integer;
begin
  result := zustaende.Count;
end;

//-------- getZustand (public) -----------------------------------------
function TxmlAutomat.getZustand : integer;
begin
  result  := Fzustand;
end;

//-------- getZustandsname (public) ------------------------------------
function TxmlAutomat.getZustandsname(nr:integer) : string;
begin
  result := zustaende[nr];
end;

//-------- destroy (public) --------------------------------------------
destructor TxmlAutomat.destroy;
begin
  zustaende.free;
  eingaben.free;
  ausgaben.free;
  inherited destroy;
end;

end.
