unit uGUI; { mk, 10.4.2004 }

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,mTxmlAutomat;

type
  TForm1 = class(TForm)
    mEingaben: TMemo; mAusgaben: TMemo; lZustand: TLabel; lEingabe: TLabel;
    lAusgabe: TLabel;
    bVerarbeite: TButton; lEingaben: TLabel; lAusgaben: TLabel;
    cbZustand: TComboBox; cbEingabe: TComboBox; cbAusgabe: TComboBox;
    bLaden: TButton;
    OpenDialog: TOpenDialog;
    bLoesche: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure bVerarbeiteClick(Sender: TObject);
    procedure bLadenClick(Sender: TObject);
    procedure bLoescheClick(Sender: TObject);
  private
    automat : TxmlAutomat;
    procedure zeigeAutomatenDetails;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  automat := TxmlAutomat.Create;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  automat.Free;
end;

procedure TForm1.zeigeAutomatenDetails;
var
  i,n : integer;
begin
  // Name des Automaten
  Form1.Caption := automat.getName;
  // Zustnde in ComboBox eintragen
  cbZustand.Clear;
  n := automat.getZustaendeN;
  for i := 0 to n-1 do
    cbZustand.AddItem(automat.getZustandsname(i),nil);
  cbZustand.ItemIndex := automat.getZustand;
  // Eingabealphabet in ComboBox eintragen
  cbEingabe.Clear;
  n := automat.getEingabenN;
  for i := 0 to n-1 do
    cbEingabe.AddItem(automat.getEingabename(i),nil);
  cbEingabe.ItemIndex := 0;
  // Ausgabealphabet in ComboBox eintragen
  cbAusgabe.Clear;
  n := automat.getAusgabenN;
  for i := 0 to n-1 do
    cbAusgabe.AddItem(automat.getAusgabename(i),nil);
  cbAusgabe.ItemIndex := 0;
end;

procedure TForm1.bVerarbeiteClick(Sender: TObject);
begin
  if (cbZustand.ItemIndex <> -1) and (cbEingabe.ItemIndex <> -1)
  then
  begin
    automat.setZustand(cbZustand.ItemIndex);
    automat.setEingabe(cbEingabe.ItemIndex);
    automat.verarbeiteEingabe;
    mEingaben.Lines.Add(automat.getEingabename(automat.getEingabe));
    cbZustand.ItemIndex := automat.getZustand;
    cbAusgabe.ItemIndex := automat.getAusgabe;
    mAusgaben.Lines.Add(automat.getAusgabename(automat.getAusgabe));
  end;
end;

procedure TForm1.bLadenClick(Sender: TObject);
var
  f            : file of char;
  beschreibung : string;
  ch           : char;
begin
  if OpenDialog.Execute then
  begin
    beschreibung := '';
    AssignFile(f,Opendialog.FileName);
    Reset(f);
    while not eof(f) do
    begin
      read(f,ch);
      beschreibung := beschreibung+ch;
    end;
    CloseFile(f);
  end;
  automat.initialisiere(beschreibung);
  zeigeAutomatenDetails;

end;


procedure TForm1.bLoescheClick(Sender: TObject);
begin
  mEingaben.Clear;
  mAusgaben.Clear;
end;

end.
